# frozen_string_literal: true

require 'puppet/provider/asadmin'
Puppet::Type.type(:jdbcconnectionpool).provide(:asadmin, parent: Puppet::Provider::Asadmin) do
  desc 'Glassfish JDBC connection pool support.'

  commands asadmin: Puppet::Provider::Asadmin.asadminpath.to_s

  def create
    args = []
    args << 'create-jdbc-connection-pool'
    args << '--datasourceclassname' << @resource[:datasourceclassname]
    args << '--restype' << @resource[:resourcetype]
    if hasProperties? @resource[:properties]
      args << '--property'
      args << "\"#{prepareProperties @resource[:properties]}\""
    end
    args << @resource[:name]
    asadmin_exec(args)
  end

  def destroy
    args = []
    args << 'delete-jdbc-connection-pool' << @resource[:name]
    asadmin_exec(args)
  end

  def exists?
    asadmin_exec(['list-jdbc-connection-pools']).each do |line|
      return true if @resource[:name] == line.chomp
    end
    false
  end
end
